<HTML>
<HEAD>
  <META NAME="GENERATOR" CONTENT="Adobe PageMill 3.0 Win">
  <TITLE>Ambient Compiler FIR</TITLE>
</HEAD>
<BODY BGCOLOR="#ffffff">

<H2>Ambient Compiler FIR</H2>

<P>The functional-intermediate code simplifies the language substantially.
This is probably what you will start from.</P>

<H3>Types and memory representation</H3>

<P>This is the expected memory representation (but the details
are up to the runtime system). The <I>heap</I> (main memory) is
made up of <I>blocks</I> and <I>integers</I>. A <I>block</I> is
a contiguous sequence of words, starting with a header word, and
followed by a sequence of pointers to other blocks, or integers.
For example, here is a possible memory layout.</P>

<P><CENTER><IMG SRC="block.gif" WIDTH="338" HEIGHT="247" ALIGN="BOTTOM"
BORDER="0" NATURALSIZEFLAG="3"></CENTER></P>

<P>The assumption is the pointers are always 32-bit aligned, and
so they are distinguishable from integers, which are always represented
with a 1 in the least-significant bit. The <I>size</I> describes
how many words in the block, and the <I>tag</I> is used for union
types. The union</P>

<BLOCKQUOTE>
  <PRE><B>type </B>'a option <B>=</B>
   None
 | Some of 'a</PRE>
</BLOCKQUOTE>

<P>has blocks with [<TT>tag=0, size=0]</TT> (to represent <TT>None</TT>),
and blocks with [<TT>tag=1, size=1]</TT> (to represent <TT>Some
x</TT>).</P>

<P>Strings are opaque blocks (<TT>tag=String_tag</TT>), with contents
that consist of a sequence of characters.</P>

<P>The types has the following meanings:</P>

<BLOCKQUOTE>
  <P><B><TT>TyInt</TT></B>: all elements are 31-bit integers</P>
  <P><B><TT>TyChar</TT>:</B> characters are encoded as 31-bit integers,
  in machine representation (usually ASCII)</P>
  <P><B><TT>TyString</TT>: </B>pointer to a block with <TT>String_tag</TT></P>
  <P><B><TT>TyFun </TT></B><TT>(t1, t2)</TT>:</P>
  <BLOCKQUOTE>
    <P>The elements of this type are functions that take arguments
    of type <TT>t1</TT> and return arguments of type <TT>t2</TT>.
    Functions are represented with <I>closures</I>. A closure is
    represented as a block with tag <TT>Closure_tag</TT>. The first
    field is a pointer to the function code, the second field is
    the number of arguments that the function expects. The remaining
    fields are filled with arguments that have been provided by partial
    application. For example, suppose we define functions <TT>f</TT>
    and <TT>g</TT>:</P>
    <BLOCKQUOTE>
      <PRE><TT>#<B> let </B>f x y z = x ^ y ^ z;;</TT>
<TT>- f : string -&gt; string -&gt; string -&gt; string</TT>
<TT></TT>
<TT>#<B> let </B>g = f &quot;hello&quot; &quot;world&quot;;;</TT>
<TT>- g : string -&gt; string</TT></PRE>
    </BLOCKQUOTE>
    <P>Both <TT>f</TT> and <TT>g</TT> are set to closures. The closure
    for <TT>f</TT> has the following fields:</P>
    <OL>
      <LI>tag = <TT>Closure_tag</TT>; size = 2
      <LI>pointer to code for <TT>f</TT>
      <LI>arg count = 3
    </OL>
    <P>When <TT>g</TT> is evaluated, it adds two arguments in a new
    closure. The closure for <TT>g</TT> is a block with these fields:</P>
    <OL>
      <LI>tag = <TT>Closure_tag</TT>; size = 4
      <LI>pointer to code for <TT>f</TT>
      <LI>arg count = 3
      <LI>pointer to string <TT>&quot;hello&quot;</TT>
      <LI>pointer to string <TT>&quot;world&quot;</TT>
    </OL>
    <P>When <TT>g</TT> is applied to the string <TT>&quot;goodbye&quot;</TT>,
    it gets the closure for <TT>g</TT>, which contains the arguments
    <TT>&quot;hello&quot;</TT> and <TT>&quot;world&quot;</TT>, then
    passes all three arguments to <TT>f</TT> (which concatenates
    them and returns <TT>&quot;helloworldgoodbye&quot;</TT>).</P>
    <P><B>Note the following issue</B>: suppose we made the following
    definition:</P>
    <BLOCKQUOTE>
      <PRE># <B>let </B>f x =
     <B>let</B> h x y z =
        x ^ y ^ z
     <B>in</B>
        h x;;
- f : string -&gt; string -&gt; string -&gt; string

# <B>let</B> g = f &quot;hello&quot; &quot;world&quot;;;
- g : string -&gt; string</PRE>
    </BLOCKQUOTE>
    <P>This code is functionally equivalent, but the representation
    is different. The closure for <TT>f</TT> is the following:</P>
    <OL>
      <LI>tag = <TT>Closure_tag</TT>; size = 2
      <LI>pointer to code for <TT>f</TT>
      <LI>argcount = 1
    </OL>
    <P>When <TT>g</TT> is applied to the first argument <TT>&quot;hello&quot;</TT>,
    the closure for <TT>f</TT> is complete (all arguments have been
    applied), and <TT>f(&quot;hello&quot;)</TT> is evaluated, returning
    the closure:</P>
    <OL>
      <LI>tag = <TT>Closure_tag</TT>; size = 2
      <LI>pointer to code for <TT>h</TT>
      <LI>argcount = 3
      <LI>pointer to <TT>&quot;hello&quot;</TT>
    </OL>
    <P>Further evaluation adds the remaining argument <TT>&quot;world&quot;</TT>
    to the closure.</P>
  </BLOCKQUOTE>
  <P><B><TT>TyProd </TT></B><TT>[t1; t2; ...; tn]</TT>:</P>
  <BLOCKQUOTE>
    <P>This is a tuple with fields of types <TT>t1</TT>, <TT>t2</TT>,
    ...,<TT> tn</TT>. Tuples are represented as blocks with tag =
    <TT>0</TT>, size = <TT>n</TT>, and the fields are filled in the
    from tuple.</P>
  </BLOCKQUOTE>
  <P><B><TT>TyRecord </TT></B><TT>[(m1, l1, t1); ...; (mn, ln,
  tn)]</TT>:</P>
  <BLOCKQUOTE>
    <P>Records are also represented as tuples (tag = <TT>0</TT>,
    size = <TT>n</TT>). The fields have types <TT>t1</TT>, ..., <TT>tn</TT>.
    The <I>mutable</I> flags <TT>m1</TT>, ..., <TT>mn</TT> are set
    of the field can be modified, and the field are <I>labeled</I>
    with the labels <TT>l1</TT>, ..., <TT>ln</TT>.</P>
  </BLOCKQUOTE>
  <P><B><TT>TyUnion</TT></B><TT> [(c1, [t11; ...; t1m]); ...; (cn,
  [tn1; ... tnl])]</TT>:</P>
  <BLOCKQUOTE>
    <P>Unions are <I>one of</I> the tuples with the given tags. Tags
    are numbered starting from 0, so blocks labeled with <TT>c1</TT>
    are given tag = 0, blocks labeled with <TT>c2</TT> are given
    tag = 1, etc. For example, the block for <TT>(c2 (a1, ..., am))</TT>
    is represented as:</P>
    <OL>
      <LI>tag = <TT>1</TT>, size = <TT>m</TT>
      <LI><TT>a1</TT>
      <LI>...
      <LI><TT>am</TT>
    </OL>
  </BLOCKQUOTE>
  <P><B><TT>TyUninitialized</TT></B><TT> ty</TT>: this is the type
  of uninitialized values of type <TT>ty</TT>.</P>
  <P><B><TT>TyArray</TT></B><TT> ty</TT>:</P>
  <BLOCKQUOTE>
    <P>Arrays are represented just like tuples, with tag = <TT>0</TT>.
    The <TT>size</TT> field is the number of elements in the array.
    All fields in an array are mutable.</P>
  </BLOCKQUOTE>
  <P><B><TT>TyParam</TT></B><TT> 'a</TT>:<BR>
  <B><TT>TyAll </TT></B><TT>([v1; ...; vn], ty)</TT>:</P>
  <BLOCKQUOTE>
    <P>These types are used to represent <I>type polymorphism</I>.
    For example, the function:</P>
    <BLOCKQUOTE>
      <PRE># <B>let </B>f x y = (x, y);;
- f : 'a -&gt; 'b -&gt; 'a * 'b</PRE>
    </BLOCKQUOTE>
    <P>has the following type:</P>
    <BLOCKQUOTE>
      <PRE><TT>TyAll ([a; b];</TT>
<TT>   TyFun (TyParam (a,</TT>
<TT>      TyFun (TyParam (b,</TT>
<TT>         TyProd ([TyParam a; TyParam b]))))</TT></PRE>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>TyApply </TT></B><TT>(ty_var, [t1; ...; tn])</TT>:</P>
  <BLOCKQUOTE>
    <P>This is a polymorphic type application. For example, consider
    the following polymorphic type:</P>
    <BLOCKQUOTE>
      <PRE># <B>type</B> 'a option =
     None
   | Some of 'a;;
# Some 1;;
- int option</PRE>
    </BLOCKQUOTE>
    <P>The type for <TT>'a option</TT> is:</P>
    <BLOCKQUOTE>
      <PRE><TT>TyAll ([a],</TT>
<TT>   TyUnion [None, [];</TT>
<TT>            Some, TyApply (option, [TyParam a]))</TT></PRE>
    </BLOCKQUOTE>
    <P>And the <TT>(Some 1)</TT> expression has type:</P>
    <BLOCKQUOTE>
      <P><TT>TyApply (option, [int])</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>TyOpen</TT></B><TT> [(v1, t1); ...; (vn; tn)]</TT>:</P>
  <BLOCKQUOTE>
    <P>Don't worry about this one for now. This is supposed to represent
    the type of messages <TT>(open AmbientName)</TT> that can modify
    the variables <TT>v1</TT>, ..., <TT>vn</TT> in this ambient.</P>
  </BLOCKQUOTE>
</BLOCKQUOTE>

<H3>Atoms (values)</H3>

<P>Atoms are the values that represent constants and vairables.
There are only two constants:</P>

<DL>
  <DD><B><TT>AtomInt</TT></B><TT> i</TT>: represents the integer
  <TT>i</TT>
  <DD><B><TT>AtomChar</TT></B><TT> c</TT>: represents the character
  constant <TT>c</TT>.
  <DD>&nbsp;
  <DD><B><TT>AtomVar </TT></B><TT>v</TT>: represents the variable
  <TT>v</TT>.
</DL>

<H2>Expressions</H2>

<H3>Normal lambda-calculus operations:</H3>

<BLOCKQUOTE>
  <P><B><TT>LetAtom </TT></B><TT>(v, ty, a, e)</TT>: </P>
  <BLOCKQUOTE>
    <P>Simple assignment, binds <TT>v</TT> to the argument <TT>a</TT>.</P>
    <BLOCKQUOTE>
      <P><B><TT>let</TT></B><TT> v : ty = a <B>in</B> e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>LetUnop</TT></B><TT> (v, ty, op, a, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Unary operation. Operations are:</P>
    <BLOCKQUOTE>
      <PRE><B>type</B> unop =
   UMinusOp    (* integer negation *)
 | NotOp       (* Boolean negation *)</PRE>
    </BLOCKQUOTE>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>let</TT> </B><TT>v : ty = op a <B>in</B> e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>LetBinop</TT></B><TT> (v, ty, op, a1, a2, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Binary arithmetic. Operations are:</P>
    <BLOCKQUOTE>
      <PRE><B>type</B> binop =
   PlusOp      (* integer addition *)
 | MinusOp     (* integer subtraction *)
 | MulOp       (* integer multiplication *)
 | DivOp       (* integer division *)
 | RemOp       (* integer remainder *)
 | LAndOp      (* integer bitwise-and *)
 | LOrOp       (* integer bitwise-or *)
 | LslOp       (* unsigned shift left *)
 | LsrOp       (* unsigned shift right *)
 | AslOp       (* signed shift left *)
 | AsrOp       (* signed shift right *)
 | XorOp       (* integer bitwise xor *)</PRE>
    </BLOCKQUOTE>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>let</TT></B><TT> v : ty = a1 op a2 <B>in</B> e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>LetFuns</TT></B><TT> ([(f1, t1, [v11; ...; v1m], e1);<BR>
             ...;<BR>
            (fn, tn, [vn1; ...; vnl], en)];<BR>
           e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Recursive function definitions. All the functions are defined
    in the bodies <TT>e1</TT>, ..., <TT>en</TT>, as well as the expression
    <TT>e</TT>.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <PRE><B>let </B>(f1 : t1) (v11, ..., v1m) = e1
<B>and</B> ...
<B>and</B> (fn : tn) (vn1, ..., vnl) = en
<B>in</B>
   e</PRE>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>LetApply</TT></B><TT> (v, ty, f, [a1; ...; an]; e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Function call. Call the function <TT>f</TT> on arguments <TT>a1</TT>,
    ..., <TT>an</TT> and bind <TT>v</TT> to the result.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>let</TT></B><TT> v : ty = f(a1, ..., an) <B>in</B>
      e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>TailCall</TT></B><TT> (f, [a1; ...; an])</TT>:</P>
  <BLOCKQUOTE>
    <P>Function tail-call. Call the function <TT>f</TT> on arguments
    <TT>a1</TT>, ..., <TT>an</TT>, and return the result.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><TT>f(a1, ..., an)</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>TailCallCC </TT></B><TT>(f, [a1; ...; an], cv)</TT>:<BR>
  <B><TT>TailApplyCC</TT></B><TT> (f, [a1; ...; an], cv)</TT>:</P>
  <BLOCKQUOTE>
    <P>Continuation-passing tail-call. In continuation-passing-style,
    the <TT>TailCall (f, args)</TT> is not used. This is for the
    problem listed under <TT>TyFun</TT> in the description of the
    types.</P>
    <P>The function <TT>f</TT> must be a closure, and suppose it
    has <TT>m</TT> remaining arguments before the function can be
    applied. There are three cases:</P>
    <BLOCKQUOTE>
      <OL>
        <LI><TT>m = n + 1</TT>: in this case, call <TT>f(a1, ..., an,
        cv)</TT>.<BR>
        <LI><TT>m &lt;= n</TT>: construct a new closure:<BR>
<BR>
        <TT>cv'(g)</TT> = <TT>g(am, ..., an, cv)</TT>,<BR>
<BR>
        and call<BR>
<BR>
        <TT>f(a1, ..., am-1, cv')</TT>.<BR>
        <LI><TT>m &gt; n + 1</TT>: add the arguments <TT>a1</TT>, ...,
        <TT>an</TT> to the closure <TT>f</TT>:<BR>
<BR>
        <TT>f' = f(a1, ..., an)<BR>
<BR>
        </TT>and call:<BR>
<BR>
        <TT>cv(f')</TT>.
      </OL>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>Return</TT></B><TT> a</TT>:</P>
  <BLOCKQUOTE>
    <P>This is used only in direct-style FIR (not continuation-passing-style).
    IT is used at the end of a function to return a value.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>return</TT></B><TT> a</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
</BLOCKQUOTE>

<H3>Control flow</H3>

<BLOCKQUOTE>
  <P><B><TT>IfThenElse</TT></B><TT> (a, e1, e2)</TT>:</P>
  <BLOCKQUOTE>
    <P>Conditional statement. The atom <TT>a</TT> should refer to
    a Boolean value. Note that the expressions <TT>e1</TT> and <TT>e2</TT>
    conclude with a tail-call or a return statement, so the conditional
    never returns a value.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>if</TT></B><TT> a <B>then</B> e1 <B>else</B> e2</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>IfTag</TT></B><TT> (a, i, e1, e2)</TT>:<BR>
  <B><TT>IfLength </TT></B><TT>(a, i, e1, e2)</TT>:</P>
  <BLOCKQUOTE>
    <P>Conditional test for memory blocks. The atom <TT>a</TT> refers
    to one of the non-integer types like tuples, records, unions,
    closures, etc.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>if</TT></B><TT> tag(a) = i <B>then</B> e1 <B>else</B>
      e2<BR>
      <B>if</B> length(a) = i <B>then</B> e1 <B>else</B> e2</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>MatchError</TT></B><TT> loc</TT>:</P>
  <BLOCKQUOTE>
    <P>Raise a <TT>MatchError</TT> exception because a pattern matching
    failed. The <TT>loc</TT> is the source file location <TT>(filename,
    start_line, start_char, end_line, end_char</TT>).</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>raise </TT></B><TT>(MatchError loc)</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>LetTry </TT></B><TT>(v1, ty, v2, e1, e2)</TT>:<BR>
  <B><TT>CallCC </TT></B><TT>(v1, ty, v2, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Don't worry about these for now--the details are not yet final.
    This is for exception handling and explicit continuation-passing
    at the source level. Due to be changed.</P>
  </BLOCKQUOTE>
</BLOCKQUOTE>

<H3>Memory Allocation and Assignment</H3>

<BLOCKQUOTE>
  <P><B><TT>LetString </TT></B><TT>(v, s, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Allocate storage for a string and bind <TT>v</TT> to it. The
    initial contents are given by string <TT>s</TT>.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>let</TT></B><TT> v = s <B>in</B> e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>LetAlloc </TT></B><TT>(v, ty, tag, size, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Allocate a memory block with tag = <TT>tag</TT>, and size
    =<TT> size</TT>. The <TT>ty</TT> gives the <I>uninitialized</I>
    type of the block. That is, all the fields should have uninitialized
    types. For example, a block of type <TT>int * string</TT> (with
    FIR type <TT>TyProd [TyInt; TyString]</TT>), would be allocated
    with type:</P>
    <BLOCKQUOTE>
      <PRE><TT>TyProd [TyUninitialized TyInt;
        TyUninitialized TyString]</TT></PRE>
    </BLOCKQUOTE>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>let </TT></B><TT>v : ty = alloc(tag, size) <B>in</B>
      e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>SetProj</TT></B><TT> (v, index, a, ty, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Set a field in the block. This also changes the type of the
    field in the block.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <PRE><TT>v.(index) &lt;- a; e</TT></PRE>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>LetProj </TT></B><TT>(v1, ty, v2, index, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Fetch the field in the memory block.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>let</TT></B><TT> v1 : ty = v2.(index) <B>in</B> e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>SetStringSubscript </TT></B><TT>(s, index, c, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Set a character in a string.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><TT>s.[index] &lt;- c; e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>LetStringSubscript </TT></B><TT>(v, s, index, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Get a character from a string.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>let</TT></B><TT> v = s.[index] <B>in</B> e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
</BLOCKQUOTE>

<H3>Ambient operations</H3>

<BLOCKQUOTE>
  <P><B><TT>LetName</TT></B><TT> (self, Name, ty, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Create a new name for an ambient. Future ambients can be given
    this name, and actions <TT>(in Name)</TT>, <TT>(out Name)</TT>,
    and <TT>(open Name)</TT> can be generated from the name. The
    <TT>self</TT> parameter is the variable that refers to the current
    ambient.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>let</TT></B><TT> Name = name(self) <B>in</B> e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>Ambient </TT></B><TT>(self, Name, f, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Create a new ambient. The <TT>self</TT> variable refers to
    the current ambient (the new ambient will be a sub-ambient);
    the <TT>f</TT> variable refers to a function that gives the body
    of the ambient; <TT>Name</TT> is the name of the ambient, and
    <TT>e</TT> is the expression to run after creating the ambient.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>ambient</TT></B><TT> Name(self, f); e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>Thread </TT></B><TT>(self, f, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Create a new thread. The <TT>self</TT> variable refers to
    the current ambient; the <TT>f</TT> variable refers to a function
    that will be called in the new thread; and the expression <TT>e</TT>
    is executed after starting the new thread.</P>
    <P>Print representation:</P>
    <BLOCKQUOTE>
      <P><B><TT>thread </TT></B><TT>(self, f); e</TT></P>
    </BLOCKQUOTE>
  </BLOCKQUOTE>
  <P><B><TT>Migrate</TT> </B><TT>(self, a, e)</TT>:</P>
  <BLOCKQUOTE>
    <P>Migrate the current ambient. The <TT>self</TT> variable refers
    to the current ambient; the atom <TT>a</TT> refers to an action
    (the <TT>in</TT>, <TT>out</TT>, or <TT>open</TT>) to take, and
    the expression <TT>e</TT> is what to do after migrating.</BLOCKQUOTE>
</BLOCKQUOTE>

</BODY>
</HTML>
